pragma solidity >=0.6.12;

// Author:	Louis Holbrook <dev@holbrook.no> 0826EDA1702D1E87C6E2875121D2E7BB88C2A746
// SPDX-License-Identifier:	GPL-3.0-or-later
// File-version: 1
// Description: The ERC20 standard interface as specified in EIP20 (sha256:9f843cbb25a737c9351b0b6a6f54b86864490d0d5284f6877b4929d481d34312)

interface AddressDeclarator {
	function addDeclaration(address _address, bytes32 _proof) external returns ( bytes32 );
	function declaratorCount(address _objectAddress) external view returns ( uint256 );
	function declaratorAddressAt(address _targetAddress, uint256 _idx) external view returns ( address );
	function declaration(address _subjectAddress, address _objectAddress) external view returns ( bytes32[] memory );
	function declarationCount(address _subjectAddress) external view returns ( uint256 );
	function declarationAddressAt(address _subjectAddress, uint256 _idx) external view returns ( address );
}
