pragma solidity >=0.6.12;

// Author:	Louis Holbrook <dev@holbrook.no> 0826EDA1702D1E87C6E2875121D2E7BB88C2A746
// SPDX-License-Identifier:	GPL-3.0-or-later
// File-version: 1
// Description: The ERC20 standard interface as specified in EIP20 (sha256:9f843cbb25a737c9351b0b6a6f54b86864490d0d5284f6877b4929d481d34312)


// TODO: Rename everything to something more generic
interface TokenEndorser {
	function endorsement(bytes32) external view returns ( bytes32 );
	function tokenIndex(address) external view returns ( uint256 );
	function endorser(address, uint256) external view returns ( uint256 );
	function endorserTokenCount(address) external view returns ( uint256 );
	function tokenSymbolIndex(string memory) external view returns ( address );
	function tokens(uint256) external view returns ( address );
	function add(address _token, bytes32 _data) external returns ( bool );
}
